/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    apiMSG.h
 *
 * Date:        May 1994
 *
 * Purpose:     include file for apiMSG.c
 *
 * Author(s):   Vincent Berkhout, Frederic P. H. van Hengstum
 *
 * -----------------------------------------------------------------------
 */

#ifndef APIMSG_H
#define APIMSG_H

#include <apiSNMP.h>


#define NAMEMAX	256
#define	VARBINDLISTMAX (4*1024) 	/* don't know ... */
#define MSGTABLEMAX 10

/*
 *	Message definition to be used for management communication.
 */
typedef struct {
 	SPTYPE	type;
	char    systemname[ NAMEMAX ];      /* name of managed system */
	QOS     qos;
	char    contextname[ NAMEMAX ];
	AsnInt 	request_id;
	AsnInt	errorstatus;    	/* or non-repeaters */
	AsnInt	errorindex;     	/* or max-repetitions */
	char    variablebindings[VARBINDLISTMAX];
} MSG;

typedef MSG MSGTABLE[ MSGTABLEMAX ];

EXTERN STATUS msgOpen( AsnInt *mHandle, MSG **mMsg );
EXTERN STATUS msgPut( SPTYPE mType, char *mSysName, QOS mQos, 
		      char *mConName, AsnInt mReqId, 
		      VarBindList *mVarBinds, AsnInt mErrStat,
		      AsnInt mErrInd, AsnInt mHandle );
EXTERN STATUS msgGet( SPTYPE *mType, char *mSysName, QOS *mQos, 
		      char *mConName, AsnInt *mReqId, 
		      VarBindList *mVarBinds, AsnInt *mErrStat,
		      AsnInt *mErrInd, AsnInt *mHandle );
EXTERN STATUS msgClose( AsnInt mHandle );

#endif	/* APIMSG_H */

