/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    spmAWM.h
 *
 * Date:        May 1994
 *
 * Purpose:     This file implements the Application Interface Module.
 *
 * Author(s):   Vincent Berkhout, Frederic P. H. van Hengstum
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMAWM_H
#define SPMAWM_H

#ifndef VERSION_1
#define VERSION_1 0
#endif

#include <apiMSG.h>
#include <spmCR.h>
/* #include <spmAIM.h> */
#include <spmTIM.h>
#include <sim.h>


/*
 *	READABILITY DEFINES ...
 */
#define SpmInitAim AimOpen
#define MAXAPPLICATIONS 32
#define MAXIDS		100

typedef IADDRESS APPLICATIONTABLE[ MAXAPPLICATIONS ];

/*
 *      local variables
 */
static APPLICATIONTABLE applicationTable;
static unsigned int     spmIds = 0;
static unsigned int     applicationsConnected = 0;

static int SNMP_DEBUG_AIM = 40;
static int SNMP_DEBUG_AIM_META = 41;

EXTERN struct hostent *gethostbyname() ;

EXTERN STATUS AimOpen PROTO(()) ;
EXTERN STATUS AimReceive PROTO(( 
	AsnInt *version, UAsnInt *mSrcId, UAsnInt *mDstId, UAsnInt *mCtxId,
	AsnInt *mType, AsnInt *mReqId, AsnInt *mErrStat, AsnInt *mErrInd, 
	VarBindList **mVarBinds, AsnOcts *tAddress, AsnOcts *community ));
EXTERN STATUS AimSend PROTO(( 
	AsnInt version, UAsnInt mSrcId, UAsnInt mDstId, UAsnInt mCtxId, 
	PDUsChoiceId mType, AsnInt mReqId, AsnInt mErrStat, AsnInt mErrInd,
	VarBindList *mVarBinds )) ;
EXTERN STATUS AimClose PROTO(()) ;

#endif /* ! SPMAWM_H */

/* -------------------- end of file spmAWM.h ------------------------ */
