/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmBERV2.h
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to Basic Encoding Rules module.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
*/

#ifndef SPMBER2_H
#define SPMBER2_H

#include <snmpTypes.h>
#include <spmMD5.h>
#include <malloc.h>
#include <BerVarBindList.h>


#ifndef UNAUTH
#define	UNAUTH	0
#endif

#ifndef AUTH
#define AUTH	1
#endif

static int SNMP_DEBUG_BER = 70;

EXTERN STATUS BerDecodePrivMsg PROTO(( AsnOcts *privMsg, 
		AsnOid **privDst, AsnOcts **privData )) ;
EXTERN STATUS BerDecodeAuthMsg PROTO(( AsnOcts *authMsg, AsnOcts **authDigest,
		AsnInt *authDstTimestamp, AsnInt *authSrcTimestamp,
		AsnLen *authDigestOffset, AsnOcts **authData ));
EXTERN STATUS BerDecodeCommMsg PROTO(( AsnOcts *commMsg, AsnOid **srcParty, 
		AsnOid **dstParty, AsnOid **context, AsnOcts **pdu, PDUsChoiceId *tag ));
EXTERN STATUS BerDecodeV2Pdu PROTO(( AsnOcts *pdu, PDUsChoiceId *tag,
		AsnInt *requestid, AsnInt *errorstatus, AsnInt *errorindex,
		VarBindList **varbindlist ));

#endif /* SPMBER2_H */

/* ---------------------------- end of file spmBer2.h ----------------------- */
