/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    spmList.h
 *
 * Date:        May 1994
 *
 * Purpose:     headerfile for spmList.c
 *
 * Author(s):   Frederic P. H. van Hengstum, Vincent Berkhout
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMLIST_H
#define SPMLIST_H

#include <apiSNMP.h>
#include <sim.h>
#include <spmTIM.h>

#define LOCALTIMEOUT  (30)
#define REMOTETIMEOUT (30)

/*
 *	Generic definition of remote request-list.
 */
typedef struct REMOTEENTRY {
	AsnInt spmId;
	AsnInt appId;
	AsnInt type;
	IADDRESS address; 
	long timestamp;
	struct REMOTEENTRY *next;
} REMOTEENTRY;


/*
 *	Generic definition of local request-list.
 */
typedef struct LOCALENTRY {
	AsnInt spmId;
	AsnInt reqId;
	UAsnInt src, dst, ctx;
	IADDRESS address; 
	AsnInt domain;
	long timestamp;
	struct LOCALENTRY *next;
} LOCALENTRY;

/*
 *      local variables
 */
static REMOTEENTRY *remoteTable=NULL;
static LOCALENTRY *localTable=NULL;

static BOOLEAN SNMP_DEBUG_ADMIN = FALSE;

/*
 *	Generic definition of local request-list.
 */
typedef struct V1ENTRY {
	AsnOcts *community;
	AsnOcts *address;
	struct V1ENTRY *next;
} V1ENTRY;

/*
 *      local variables

EXTERN STATUS SpmInitAdminMib  PROTO(()) ;
EXTERN STATUS MibInsertLocalEntry PROTO(( AsnInt reqId, UAsnInt src, 
		UAsnInt dst, UAsnInt ctx, AsnOcts *address, AsnInt domain ));
EXTERN STATUS MibInsertLocalId PROTO(( AsnInt reqId, AsnInt spmId ));
EXTERN STATUS MibDeleteLocalEntry PROTO(( AsnInt spmId, AsnInt *reqId, 
		UAsnInt *src, UAsnInt *dst, UAsnInt *ctx, AsnOcts *address,
		AsnInt *d ));
EXTERN STATUS MibUpdateLocalEntry PROTO(());
EXTERN STATUS MibInsertRemoteEntry PROTO(( AsnInt appId, AsnInt spmId, 
		AsnInt type, IADDRESS address));
EXTERN STATUS MibDeleteRemoteEntry PROTO(( AsnInt spmId, AsnInt *appId, 
		AsnInt *type, IADDRESS address));
EXTERN STATUS MibUpdateRemoteEntry PROTO(( AsnInt *appId, IADDRESS address));
*/

#endif /*--------------  end of file spmList.h  ------------------*/
