/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmPERV1.h
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to PERV2 module.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMPER1_H
#define SPMPER1_H

#include <snmpTypes.h>



EXTERN STATUS PerDecodeV1Message PROTO(( AsnOcts *messageV1, AsnInt *version, 
           AsnOcts **community, PDUsChoiceId *tag, AsnOcts **pdu));

EXTERN STATUS PerDecodeV1Pdu PROTO(( AsnOcts *pdu, PDUsChoiceId tag,
            AsnInt *requestid, AsnInt *errorstatus, AsnInt *errorindex, 
            VarBindList **varbindlist, AsnOcts **enterprise, 
            AsnOcts **agent_addr, AsnInt *generic_trap,
            AsnInt *specific_trap, UAsnInt *time_stamp));


EXTERN STATUS PerEncodeV1Message PROTO((AsnOcts **messageV1, AsnInt version,
            AsnOcts *community, PDUsChoiceId tag, AsnInt requestid,
            AsnInt errorstatus, AsnInt errorindex, VarBindList *variablebindings,
            AsnOcts *enterprise, AsnOcts *agent_addr, AsnInt generic_trap,
            AsnInt specific_trap, UAsnInt time_stamp));

#endif /* SPMPER1_H */

/* ---------------------------- end of file spmPer1.h ----------------------- */
