/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    spmSend.h
 *
 * Date:        May 1994
 *
 * Purpose:	include file for spmSend.c	
 *
 * Author(s):	Vincent Berkhout, Frederic P. H. van Hengstum,
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMSEND_H
#define SPMSEND_H

#include <sim.h>
#include <spmTIM.h>
#include <spmAWM.h>
#include <spmMD5.h>
#include <spmDES.h>
#include <spmBer1.h>
#include <spmBer2.h>
#include <spmPartyMIB.h>
#include <spmSnmpMIB.h>
#include <spmList.h>

static int SNMP_DEBUG_SEND = 10 ;

/*
 *	EXPORT FUNCTIONS
 * -------------------------------------------------------------------
 * Function:    SpmInitSend
 * Arguments:   none 
 * Returns:     STATUS  which is OK on succes
 * Purpose:     assign the value of some global "constants"
 * -------------------------------------------------------------------
 */
EXTERN	STATUS SpmInitSend  PROTO(()) ;

/*
 * -------------------------------------------------------------------
 * Function:	SpmSend 	
 * Arguments:	srcOid,		identification of originating party (IN). 	
 *		dstOid,		identifictaion of receiving party (IN). 
 *		contextOid, 	desired SNMPv2 context (IN).
 *		pdu 		desired management operation (IN) 
 * Returns:	STATUS	which is OK on succes
 * Purpose:	This is the procedure to generate a request/trap or a response
 *		This is done according to RFC1445 par 3.1 and par 3.3
 * Remarks:	Mind that the steps 1 and 7 are different, w.r.t. retreiving used
 * 		components from partymib versus the original request!
 * -------------------------------------------------------------------
 */
EXTERN STATUS SpmSend PROTO(( )) ;

/* static BOOLEAN SNMP_DEBUG_SEND = FALSE ; */

INTERN STATUS SpmWrap PROTO(()) ; 

#endif /* ! SPMSEND_H */


			/* -- end of file spmSend.h -- */

