/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    apiSNMP.c
 *
 * Date:        May 1994
 *
 * Purpose:     This file implements the interface to the SNMP environment.
 *
 * Author(s):   J.W.Togtema, Eric van Hengstum, Vincent Berkhout
 *		Anton Holleman
 *
 * -----------------------------------------------------------------------
 */

#include <apiSNMP.h>



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetRequest( NAME host, NAME application, 
		INTEGER requestId,
		QOS qos, VARLIST *variableNames )
{
	return( 
		snmpSendRequest( 
			GET_REQ, host, requestId, qos, 0, 0,
			application, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetIndication( INTEGER *replyId, 
		   VARLIST **variableNames )
{
	return( 
		snmpReceiveIndication( 
			GET_IND, replyId, NULL, NULL, NULL, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetResponse( INTEGER replyId, 
		 INTEGER errorStatus, INTEGER errorIndex, VARLIST *variableValues )
{
	return( 
		snmpSendResponse( 
			GET_RSP, replyId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetConfirm( INTEGER *requestId,
		INTEGER *errorStatus, INTEGER *errorIndex, VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			GET_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetNextRequest( NAME host, NAME application, 
		    INTEGER requestId, 
		    QOS qos, VARLIST *variableNames )
{
	return( 
		snmpSendRequest( 
			GETNEXT_REQ, host, requestId, qos, 0, 
			0, application, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetNextIndication( INTEGER *replyId, VARLIST **variableNames )
{
	return( 
		snmpReceiveIndication( 
			GETNEXT_IND, replyId, NULL, NULL, NULL, 
			variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetNextResponse( INTEGER replyId,
		     INTEGER errorStatus, INTEGER errorIndex, 
		     VARLIST *variableValues )
{
	return( 
		snmpSendResponse( 
			GETNEXT_RSP, replyId, errorStatus, errorIndex, 
			variableValues ) ); 
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetNextConfirm( INTEGER *requestId,
		    INTEGER *errorStatus, INTEGER *errorIndex, 
		    VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			GETNEXT_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetBulkRequest( NAME host, NAME application, 
		    INTEGER requestId, 
		    QOS qos, INTEGER maxRepetitions, INTEGER nonRepeaters, 
		    VARLIST *variableNames )
{
	return( 
		snmpSendRequest( 
			GETBULK_REQ, host, requestId, qos, maxRepetitions,
			nonRepeaters, application, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetBulkIndication( INTEGER *replyId, 
		       INTEGER *maxRepetitions, INTEGER *nonRepeaters,
		       VARLIST **variableNames )
{
	return( 
		snmpReceiveIndication( 
			GETBULK_IND, replyId, maxRepetitions, nonRepeaters, 
			NULL, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetBulkResponse( INTEGER replyId, 
		     INTEGER errorStatus, INTEGER errorIndex, 
		     VARLIST *variableValues )
{
	return( 
		snmpSendResponse( 
			GETBULK_RSP, replyId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpGetBulkConfirm( INTEGER *requestId, 
		    INTEGER *errorStatus, INTEGER *errorIndex, 
		    VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			GETBULK_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpSetRequest( NAME host, NAME application,
		INTEGER requestId,
		QOS qos, VARLIST *variableValues )
{
	return( 
		snmpSendRequest( 
			SET_REQ, host, requestId, qos, 0, 0, application,
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpSetIndication( INTEGER *replyId, VARLIST **variableValues )
{
	return( 
		snmpReceiveIndication( 
			SET_IND, replyId, NULL, NULL, NULL, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	
 *		
 * Arguments:	see manual page.
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpSetResponse( INTEGER replyId,
		 INTEGER errorStatus, INTEGER errorIndex )
{
	return( 
		snmpSendResponse( 
			SET_RSP, replyId, errorStatus, errorIndex, NULL ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpSetConfirm( INTEGER *requestId, 
		INTEGER *errorStatus, INTEGER *errorIndex )
{
	VARLIST *variableValues; /* memory leak */

	return( 
		snmpReceiveConfirm( 
			SET_CNF, requestId, errorStatus, errorIndex, 
			&variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpInformRequest( NAME host, NAME application, 
		   INTEGER requestId, 
		   QOS qos, VARLIST *variableValues )
{
	return( 
		snmpSendRequest( 
			INFORM_REQ, host, requestId, qos, 0, 0, 
			application, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks: 	Does this servicee primitib=ve really exist? (vb)
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpInformIndication( NAME host, NAME application, VARLIST **variableValues )
{
	return( 
		snmpReceiveNotification( 
			INFORM_IND, host, application, variableValues ) );
}


/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpInformConfirm( INTEGER *requestId, INTEGER *errorStatus, 
					INTEGER *errorIndex, VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			INFORM_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpTrapRequest( VARLIST *variableValues )
{
	return( 
		snmpSendRequest( 
			TRAP_REQ, NULL, (INTEGER) NULL, (QOS) NULL, (INTEGER) NULL,
			(INTEGER) NULL, NULL, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpTrapIndication( NAME host, NAME application, 
		    VARLIST **variableValues )
{
	return( 
		snmpReceiveNotification( 
			TRAP_IND, host, application, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	snmpMetaGetRequest
 *		
 * Arguments:	requestId, request identifier (IN).	
 *		variableNames, list of variable binding to be request (OUT)
 *		
 * Purpose:     This function issues an get request to the spm, which dispatches
 *		the request to the PartyMIB module. This module tries to
 *		fulfill the request.
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaGetRequest( INTEGER requestId, VARLIST *variableNames )
{
	return( 
		snmpSendRequest( 
			META_GET_REQ, NULL, requestId, (QOS)NULL, 0, 0,
			NULL, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	snmpMetaGetConfirm
 *		
 * Arguments:	requestId, request Identifier (OUT)
 *		errorStatus, type of error (OUT)
 *		errorIndex, indexes variable (OUT)
 *		variableValues, retrieved variablevalues (OUT)
 *		
 * Purpose:     This function provides thr retrieved variable-value bindings
 *		to the application.
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaGetConfirm( INTEGER *requestId, INTEGER *errorStatus, 
		    INTEGER *errorIndex, VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			META_GET_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	snmpMetaGetNextRequest
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaGetNextRequest( INTEGER requestId, VARLIST *variableNames )
{
	return( 
		snmpSendRequest( 
			META_GETNEXT_REQ, NULL, requestId, (QOS) NULL, 0, 
			0, NULL, variableNames ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaGetNextConfirm( INTEGER *requestId, INTEGER *errorStatus, 
			INTEGER *errorIndex, VARLIST **variableValues )
{
	return( 
		snmpReceiveConfirm( 
			META_GETNEXT_CNF, requestId, errorStatus, errorIndex, 
			variableValues ) );
}




/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaSetRequest( INTEGER requestId, VARLIST *variableValues )
{
	return( 
		snmpSendRequest( 
			META_SET_REQ, NULL, requestId, (QOS)NULL, 0, 0,
			NULL, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaSetConfirm( INTEGER *requestId, INTEGER *errorStatus, 
		    INTEGER *errorIndex )
{
	VARLIST *variableValues; /* memory leak */

	return( 
		snmpReceiveConfirm( 
			META_SET_CNF, requestId, errorStatus, errorIndex, 
			&variableValues ) );
}


/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaCommitRequest( INTEGER requestId )
{
	VARLIST *variableValues; /* memory leak */
	return( 
		snmpSendRequest( 
			META_COMMIT_REQ, NULL, requestId, (QOS)NULL, 0, 0,
			NULL, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaCommitConfirm( INTEGER *requestId, INTEGER *errorStatus )
{
	VARLIST *variableValues; /* memory leak */

	return( 
		snmpReceiveConfirm( 
			META_COMMIT_CNF, requestId, errorStatus, 0, 
			&variableValues ) );
}

/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaUndoRequest( INTEGER requestId )
{
	VARLIST *variableValues; /* memory leak */
	return( 
		snmpSendRequest( 
			META_UNDO_REQ, NULL, requestId, (QOS)NULL, 0, 0,
			NULL, variableValues ) );
}



/* 
 * -----------------------------------------------------------------------
 *		
 * Function:	see manual page.
 *		
 * Arguments:	
 *		
 * Purpose:     
 *		
 * Remarks:
 *		
 * -----------------------------------------------------------------------
 */
	STATUS
snmpMetaUndoConfirm( INTEGER *requestId, INTEGER *errorStatus )
{
	VARLIST *variableValues; /* memory leak */

	return( 
		snmpReceiveConfirm( 
			META_UNDO_CNF, requestId, errorStatus, 0, 
			&variableValues ) );
}


/* -----------------------------------------------------------------------
 */
