/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    spmSnmpMib.c
 *
 * Date:        May 1994
 *
 * Purpose:     implementation of the traps group of the snmpV2 Mib for 
 *		version 2 as defined in RFC 1450 page 13 
 *
 * Author(s):   Vincent Berkhout
 *
 * -----------------------------------------------------------------------
 */

#include <spmSnmpMIB.h>

static SNMPTRAPENTRY *trapTable=NULL;


	STATUS
MibInitTrapGroup()
{
	trapTable = NULL;
	return OK;	
}


    STATUS
MibGetTrapNumber( UAsnInt pi, AsnInt *trapNumber)
{
    BOOLEAN found;
    SNMPTRAPENTRY *ttp; /* trapTable pointer */
    SNMPTRAPENTRY *tte; /* new trap table entry */
   
    found = FALSE;
    ttp = trapTable;

    while (ttp != NULL)
        if (  pi == ttp->partyIndex ) {
            found = TRUE;
            break;
        } else  ttp = ttp->next;

	if (found == TRUE) 

		*trapNumber = ++ttp->trapNumber;

	else {

		tte = (SNMPTRAPENTRY *) malloc( sizeof(SNMPTRAPENTRY) ) ;
		if (tte == NULL)
			return FAILED;
		tte->partyIndex = pi;
		tte->trapNumber = *trapNumber = 1 ;
		if ( trapTable == NULL )
			tte->next = NULL;
		else tte->next = trapTable ;
		trapTable = tte;
	}

	return OK ;
	
}
